/* Comix, Copyright 1996, Eric C Harshbarger.
This code is available for public use and modification as long as this notice of copyright is kept in tact. Additional credit is allowable for modifications.

Documentation on this applet may be found at:
http://www.auburn.edu/^harshec/WWW/slideshow.html

Questions or comments should be directed to:

Eric Harshbarger ( http://www.auburn.edu/^harshec/ )
harshec@mail.auburn.edu   OR    harshec@cdware.eng.sun.com   */

import java.applet.*;
import java.awt.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.lang.*;
import java.util.Hashtable;
import java.net.URL;
import java.awt.image.*;
import java.net.MalformedURLException;

public class Comix1 extends Applet implements Runnable {

	Thread woohoo;
	Image background;
	Image bufimage;
	Graphics bufgraphic;
	Dimension roo;
	String param,pp,fonttype;
	String parampiece;
	String type[] = new String[6];
	String words[] = new String[6];
	String mouth[] = new String[6];
	int a=0;
	int fontsize;
	int bubblex[] = new int[6];
	int bubbley[] = new int[6];
	boolean bubbleon[] = new boolean[6];

	public void init() {
		roo = this.size();
		bufimage = createImage(roo.width,roo.height);
		bufgraphic = bufimage.getGraphics();

		pp = getParameter("FONTSIZE");
		fontsize = (pp != null) ? Integer.parseInt(pp) : 14;

		pp = getParameter("FONTTYPE");
		fonttype = (pp != null) ? pp : "Courier";
	}

	public void paint(Graphics g) {
		paintBuffer(bufgraphic);
		g.drawImage(bufimage,0,0,this);
	}

	public void paintBuffer(Graphics g) {
		g.setColor(Color.lightGray);
		g.fillRect(0,0,roo.width,roo.height);
		if (background != null) { g.drawImage(background,0,0,this); }
		for (int i=0;i<6;i++) {
			if (bubbleon[i]) {
				drawSentence(g,words[i],mouth[i],bubblex[i],bubbley[i]);
			}
		}

		g.setColor(Color.black);
		g.drawRect(0,0,roo.width-1,roo.height-1);
		g.setColor(Color.white);
		for (int i=1;i<4;i++) {
			g.drawRect(i,i,roo.width-2*i-1,roo.height-2*i-1);
		}
		g.setColor(Color.black);
		g.drawRect(4,4,roo.width-9,roo.height-9);
	}

	public void drawSentence(Graphics g, String sentence, String mouth, int x, int y) {
		int ovalx,ovaly;
		Font f = new Font(fonttype,0,fontsize);
		g.setFont(f);
		FontMetrics fm = g.getFontMetrics();
		StringTokenizer st1 = new StringTokenizer(sentence+"/","/");
		int lines = st1.countTokens();
		int linex[] = new int[lines];
		String liness[] = new String[lines];
		int longestline = 0;
		int i=0;
		while (st1.hasMoreTokens()) {
			liness[i] = st1.nextToken();
			StringTokenizer st3 = new StringTokenizer(liness[i],"{");
			linex[i] = fm.stringWidth(liness[i])-(st3.countTokens()-1)*(fm.stringWidth("{")*3);
			longestline = Math.max(longestline,linex[i]);
			i++;
		}
		int bubwidth = (int)(longestline*1.25);
		int bubheight = (int)((fm.getHeight()*lines+fm.getLeading()*(lines-1))*2);

		if (mouth.equals("ne")) { ovalx = x; ovaly = y-bubheight; }
		else if (mouth.equals("se")) { ovalx = x; ovaly = y; }
		else if (mouth.equals("sw")) { ovalx = x-bubwidth; ovaly = y; }
		else { ovalx = x-bubwidth; ovaly = y-bubheight; }

		g.setColor(Color.white);
		g.fillOval(ovalx,ovaly,bubwidth,bubheight);
		g.setColor(Color.black);
		g.drawOval(ovalx,ovaly,bubwidth,bubheight);
		g.setColor(Color.white);

		int polyx[] = new int[3];
		int polyy[] = new int[3];
		polyx[0] = x;
		polyy[0] = y;
		polyx[1] = ovalx+bubwidth/2-bubwidth/6;
		polyy[1] = ovaly+bubheight/2;
		polyx[2] = ovalx+bubwidth/2+bubwidth/6;
		polyy[2] = ovaly+bubheight/2;
		g.fillPolygon(polyx,polyy,3);

		g.setColor(Color.black);

		g.drawLine(polyx[0],polyy[0],polyx[1],polyy[1]);
		g.drawLine(polyx[0],polyy[0],polyx[2],polyy[2]);

		g.setColor(Color.white);
		g.fillOval(ovalx+1,ovaly+1,bubwidth-2,bubheight-2);

		g.setColor(Color.black);

		String currentword;
		int centerx = ovalx+bubwidth/2;
		int centery = ovaly+bubheight/2;
		int startx,starty;

		for (int j=0;j<lines;j++) {
			StringTokenizer st = new StringTokenizer(liness[j]);
			startx = centerx - linex[j]/2;
			int textheight = (lines*fm.getHeight());
			starty = (int)(centery-textheight/2+(j+1)*fm.getHeight()-lines);
			while (st.hasMoreTokens()) {
				currentword = st.nextToken();
				boolean tag = false;
				tag = (currentword.indexOf("{") != -1) ? true : false;
				if (tag) {
					if (currentword.substring(1,2).equalsIgnoreCase("b")) {
						currentword = currentword.substring(3);
						f = new Font(fonttype,Font.BOLD,fontsize);
						g.setFont(f);
						g.drawString(currentword,startx,starty);
					}
					else if (currentword.substring(1,2).equalsIgnoreCase("i")) {
						currentword = currentword.substring(3);
						f = new Font(fonttype,Font.ITALIC,fontsize);
						g.setFont(f);
						g.drawString(currentword,startx,starty);
					}
					else if (currentword.substring(1,2).equalsIgnoreCase("u")) {
						currentword = currentword.substring(3);
						f = new Font(fonttype,Font.PLAIN,fontsize);
						g.setFont(f);
						g.drawString(currentword,startx,starty);
						g.drawLine(startx,starty+1,startx+fm.stringWidth(currentword),starty+1);
					}
				}
				else {
					f = new Font(fonttype,Font.PLAIN,fontsize);
					g.setFont(f);
					g.drawString(currentword,startx,starty);
				}
				fm = g.getFontMetrics();
				startx = startx+fm.stringWidth(currentword+" ");
			}
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void start() {
		if (woohoo == null) {
			woohoo = new Thread(this);
			woohoo.start();
		}
	}

	public void stop () {
		woohoo = null;
	}

	public void run() {
		int pipe;

		while (getParameter("ACTION"+a) != null) {

		param = getParameter("ACTION"+a);
		if (param != null) {
			pipe = param.indexOf("|");
			parampiece = param.substring(0,pipe);
			if (parampiece.indexOf("BUBBLE") != -1) {
				int bubblenumber = Integer.parseInt(parampiece.substring(6));
				bubbleon[bubblenumber] = true;
				StringTokenizer st = new StringTokenizer(param.substring(pipe+1),"|");
				while (st.hasMoreTokens()) {
					type[bubblenumber] = st.nextToken();
					mouth[bubblenumber] = st.nextToken();
					bubblex[bubblenumber] = Integer.parseInt(st.nextToken());
					bubbley[bubblenumber] = Integer.parseInt(st.nextToken());
					words[bubblenumber] = st.nextToken();
					repaint();
				}
			}
			else if (parampiece.equals("WAIT")) {
				int pause = Integer.parseInt(param.substring(pipe+1));
				try {Thread.sleep(pause);} catch (InterruptedException e){};
			}
			else if (parampiece.equals("CLEAR")) {
				StringTokenizer st = new StringTokenizer(param.substring(pipe+1),"|");
				while (st.hasMoreTokens()) {
					int bubblenumber = Integer.parseInt(st.nextToken().substring(6));
					bubbleon[bubblenumber] = false;
					repaint();
				}
			}
			else if (parampiece.equals("BACKGROUND")) {
				background = getImage(getDocumentBase(),param.substring(pipe+1));
				repaint();
			}
			else if (parampiece.equals("LOOPBACKTO")) {
				a = Integer.parseInt(param.substring(pipe+1))-1;
			}
		}
		a++;
		}
	}


/*	public boolean mouseEnter(java.awt.Event evt, int mx, int my) {
	}

	public boolean mouseExit(java.awt.Event evt, int mx, int my) {
	}

	public boolean mouseDown(java.awt.Event evt, int mx, int my) {
	}*/



}
